{
   ____  __   _    _____   _  _  __  __  ___
  /  _ \/  \ / \__/  /  \ / \/ \/  \/  \/ _ |
_/     /    |  /    /    |  / - \      |  __/
\__/\  \ /|   /  / /  /|   /  _  \|\/| | |__team
     \__| \__/\___/\_/ \__/\_/ \_//  \_/____\
             __
            (/ ;       /
by          /  : _  _ /
   |\/||"._/_.'_(/_(_/_ http://rndname.narod.ru/
}

unit index;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ExtCtrls, Registry, ComCtrls;

type
  TForm1 = class(TForm)
    PopupMenu1: TPopupMenu;
    Close1: TMenuItem;
    About1: TMenuItem;
    Memo1: TMemo;
    Timer1: TTimer;
    Settings1: TMenuItem;
    Timer2: TTimer;
    Image1: TImage;
    Timer3: TTimer;
    N3: TMenuItem;
    N2: TMenuItem;
    Image3: TImage;
    Image5: TImage;
    Memo2: TMemo;
    ProgressBar1: TProgressBar;
    TrayIcon1: TTrayIcon;
    procedure TrayIcon1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TrayIcon1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Settings1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N2Click(Sender: TObject);


  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  NowDate,          //-
  day,              //
  NowTime,          // 
  showForm,         // 
  showDialog,       // 
  time,             //
  REGname,          //
  skin,             //
  baseToFile,       //  
  AlarmTime,         // 
  calTrayEnabled,   // /
  calTrayBlend,     // 
  calTrayPosition,   // 
  OnClickShowCal,     //     
  OnClickShowDialog,  //     
  OnClickShowForm     //     
                    :string;
  startProgram:integer; //  
  base:TStrings;     //    

implementation

uses Unit3, Unit2, Unit4, Unit6, Unit7, Unit8, Unit10;

{$R *.dfm}
{$R WinXP.res}

//------------------      -------//
{procedure RegIcon;
var Reg:TRegistry;
begin
 reg:=Tregistry.Create;
 with reg do
 begin
  RootKey:=HKEY_CLASSES_ROOT;
  OpenKey('.skin',True);
  WriteString('', 'SKINfile');
  CloseKey;
  Createkey('skin'+'file_cyd');
  OpenKey('SKINfile\DefaultIcon', True);
  WriteString('', Application.ExeName+ ',0');

  RootKey:=HKEY_CLASSES_ROOT;
  OpenKey('.rndbase',True);
  WriteString('', 'rulezDateBase');
  CloseKey;
  Createkey('rndbase'+'file_cyd');
  OpenKey('rulezDateBase\DefaultIcon', True);
  WriteString('', Application.ExeName+ ',0');

  Free;
 end;
end;}
//--------------END-      -------//
//------------------    -------------------//
procedure UpdateSettings;
var Reg:TregIniFile;
    i:integer;
begin
 reg:=TRegIniFile.Create('Software');
 reg.OpenKey('RNDName team',true);
 showForm:=reg.ReadString('rulezDate','showForm','false');     //     
 showDialog:=reg.ReadString('rulezDate','showDialog','false'); //   
 time:=reg.ReadString('rulezDate','timer','0');                // 
 REGname:=reg.ReadString('rulezDate','name','');               // 
 skin:=reg.ReadString('rulezDate','skin','false');             //  
 baseToFile:=reg.ReadString('rulezDate','base','false');
 startProgram:=StrToInt(reg.ReadString('rulezDate','startProgram','595'));  //  
 AlarmTime:=reg.ReadString('rulezDate','AlarmTime','false'); // 
 calTrayEnabled:=reg.ReadString('rulezDate','calTrayEnabled','false');
 calTrayBlend:=reg.ReadString('rulezDate','calTrayBlend','255');
 calTrayPosition:=reg.ReadString('rulezDate','calTrayPosition','false');
 OnClickShowCal:=reg.ReadString('rulezDate','OnClickShowCal','false');
 OnClickShowDialog:=reg.ReadString('rulezDate','OnClickShowDialog','false');
 OnClickShowForm:=reg.ReadString('rulezDate','OnClickShowForm','false');
 reg.free;

 NowDate:=DateToStr(now);     //   
 NowTime:=TimeToStr(now);

 Delete (NowDate,6,10);           //    
 Delete (NowTime,length(NowTime)-2,10);

 base:=TStringList.Create;             // 
 base:=Form1.Memo1.Lines;
 for i:=0 to base.Count do if NowDate=base.Strings[i] then day:=base.Strings[i+1];
end;
//--------------END-    -------------------//

//------------------    --------------------------//

function CreateRgnFromBitmap(rgnBitmap: TBitmap): HRGN;
var
  TransColor: TColor;
  i, j: Integer;
  i_width, i_height: Integer;
  i_left, i_right: Integer;
  rectRgn: HRGN;
begin
 Result := 0;
 i_width := rgnBitmap.Width;
 i_height := rgnBitmap.Height;
 transColor := rgnBitmap.Canvas.Pixels[0, 0];
 for i := 0 to i_height - 1 do
  begin
   i_left := -1;
   for j := 0 to i_width - 1 do
    begin
     if i_left < 0 then
      begin
       if rgnBitmap.Canvas.Pixels[j, i] <> transColor then
        i_left := j;
      end
     else
      if rgnBitmap.Canvas.Pixels[j, i] = transColor then
       begin
        i_right := j;
        rectRgn := CreateRectRgn(i_left, i, i_right, i + 1);
        if Result = 0 then
         Result := rectRgn
        else
         begin
          CombineRgn(Result, Result, rectRgn, RGN_OR);
          DeleteObject(rectRgn);
         end;
        i_left := -1;
       end;
    end;
   if i_left >= 0 then
    begin
     rectRgn := CreateRectRgn(i_left, i, i_width, i + 1);
     if Result = 0 then
      Result := rectRgn
     else
      begin
       CombineRgn(Result, Result, rectRgn, RGN_OR);
       DeleteObject(rectRgn);
      end;
    end;
  end;
end;
//--------------END-    --------------------------//

procedure TForm1.FormCreate(Sender: TObject);
var
    WindowRgn: HRGN;
begin
 Position:=poScreenCenter;

 {RegIcon;}

 {Image2.Picture:=Image4.Picture; }
 {Image3.Picture:=Image5.Picture; }

//------------------------   ---------------------------//
 BorderStyle := bsNone;
 ClientWidth := Image1.Picture.Bitmap.Width;
 ClientHeight := Image1.Picture.Bitmap.Height;
 windowRgn := CreateRgnFromBitmap(Image1.Picture.Bitmap);
 SetWindowRgn(Handle, WindowRgn, True);
//--------------------END-   ---------------------------//
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
    i:integer;
    FuckDate,AlarmTime:string;
    Reg:TregIniFile;
begin
 FuckDate:=NowDate;

 // 
 UpdateSettings;

 //      
 if StrToDateTime(FuckDate)<>StrToDateTime(NowDate) then
 begin
  {for i:=0 to base.Count do if NowDate=base.Strings[i] then day:=base.Strings[i+1];}

  TrayIcon1.Hint:='['+NowDate+']'+day;

  if showForm<>'false' then ShowDate.Show;

  if showDialog<>'false' then
  begin
   TrayIcon1.BalloonHint:=day;
   TrayIcon1.BalloonTitle:='['+NowDate+']:';
   TrayIcon1.BalloonFlags:=bfInfo;
   TrayIcon1.ShowBalloonHint;
  end;
 end;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var Reg:TregIniFile;
begin
 //   
 UpdateSettings;

 TrayIcon1.Hint:='['+NowDate+']'+day;

 if REGname='' then
 begin
  TrayIcon1.BalloonHint:=' !!    '+IntToStr(startProgram)+' .  !';
  TrayIcon1.BalloonTitle:='!!!';
  TrayIcon1.BalloonFlags:=bfWarning;
  TrayIcon1.ShowBalloonHint;
 end;

 if showForm<>'false' then ShowDate.Show;

  if showDialog<>'false' then
  begin
   TrayIcon1.BalloonHint:=day;
   TrayIcon1.BalloonTitle:='['+NowDate+']:';
   TrayIcon1.BalloonFlags:=bfInfo;
   TrayIcon1.ShowBalloonHint;
  end;
end;

procedure TForm1.Timer3Timer(Sender: TObject);
var skinFile:TStrings;
    Reg:TregIniFile;
    {base:TStrings;}
    i:integer;
begin
 Timer3.Enabled:=False;

 ProgressBar1.Min:=0;
 ProgressBar1.Max:=15;
 ProgressBar1.Position:=1;

 //-----------------------------------------------------------------------------
//   
 UpdateSettings;

 ProgressBar1.Position:=ProgressBar1.Position+1;

 //   
 if REGname='' then      //     
 begin
  reg:=TRegIniFile.Create('Software');                      //    
  reg.OpenKey('RNDName team',true);                         //  

  if startProgram=595 then      //       
  begin
   reg.WriteString('rulezDate','startProgram','30');
   startProgram:=30;            //    30 
  end;

  startProgram:=startProgram-1;         //  
                                        //    
  reg.WriteString('rulezDate','startProgram',IntToStr(startProgram));
 end;

 ProgressBar1.Position:=ProgressBar1.Position+1;

 UpdateSettings;             // 

  //       
 if REGname='' then
 begin
  TrayIcon1.BalloonHint:=' !!    '+IntToStr(startProgram)+' .  !';
  TrayIcon1.BalloonTitle:='!!!';
  TrayIcon1.BalloonFlags:=bfWarning;
  TrayIcon1.ShowBalloonHint;
 end;

 if time<>'0' then    // time    
 begin
  Timer2.Enabled:=true;
  Timer2.Interval:=StrToInt(time)*60000;
 end;

 ProgressBar1.Position:=ProgressBar1.Position+1;

 //         
 if baseToFile<>'false' then Memo1.Lines.LoadFromFile(baseToFile)
                        else Memo1.Lines:=Memo2.Lines;

 ProgressBar1.Position:=ProgressBar1.Position+1;

 base:=TStringList.Create;
 base:=Memo1.Lines;           //   memo1

 ProgressBar1.Position:=ProgressBar1.Position+1;

 {UpdateSettings;}

 for i:=0 to base.Count do if NowDate=base.Strings[i] then day:=base.Strings[i+1];

 TrayIcon1.Hint:='['+NowDate+']'+day;

 ProgressBar1.Position:=ProgressBar1.Position+1;

 if showDialog<>'false' then
 begin
  TrayIcon1.BalloonHint:=day;
  TrayIcon1.BalloonTitle:='['+NowDate+']:';
  TrayIcon1.BalloonFlags:=bfInfo;
  TrayIcon1.ShowBalloonHint;
 end;

 ProgressBar1.Position:=ProgressBar1.Position+1;
 //-----------------------------------------------------------------------------

 //---------------------------   -----------------------
 if (skin<>'false') and (FileExists(skin)=true) then
 begin
  Delete (skin,length(skin)-4,10);
  //    .
  if (FileExists(skin+'\showdate.bmp')=false) {or (FileExists(skin+'\form.bmp')=false)}
  then //       
  begin                                          
   beep;
   ShowMessage('  .  !');
   settings.Show;
  end else // ,   
  begin
   skinFile:=TStringList.Create;
   skinFile.LoadFromFile(skin+'.skin');

   {Image2.Picture.LoadFromFile(skin+'\form.bmp');}
   Image3.Picture.LoadFromFile(skin+'\showdate.bmp');

   ProgressBar1.Position:=ProgressBar1.Position+1;

   {with Form5 do
   begin
    Label1.Font.Color:=stringToColor(skinFile.Strings[3]);
    Memo1.Font.Color:=stringToColor(skinFile.Strings[1]);
    Label1.Color:=stringToColor(skinFile.Strings[4]);
    Memo1.Color:=stringToColor(skinFile.Strings[2]);
   end;}

   ProgressBar1.Position:=ProgressBar1.Position+1;

   with showDate do
   begin
    Label1.Font.Color:=stringToColor(skinFile.Strings[6]);
    Memo1.Font.Color:=stringToColor(skinFile.Strings[8]);
    Label1.Color:=stringToColor(skinFile.Strings[7]);
    Memo1.Color:=stringToColor(skinFile.Strings[9]);
    MonthCalendar1.CalColors.MonthBackColor:=stringToColor(skinFile.Strings[10]);
    MonthCalendar1.CalColors.TextColor:=stringToColor(skinFile.Strings[11]);
    MonthCalendar1.CalColors.TitleBackColor:=stringToColor(skinFile.Strings[12]);
    MonthCalendar1.CalColors.TitleTextColor:=stringToColor(skinFile.Strings[13]);
   end;
  end;
 end;

 ProgressBar1.Position:=ProgressBar1.Position+1;

 
 //-----------------------end-   -----------------------

 if (startProgram<=0) and (REGname='') then    //      
 begin
  ShowMessage(',     :( !');
  close;
 end;

 ProgressBar1.Position:=ProgressBar1.Position+1;

 //          
 //    :)     ,
 //    
 if startProgram>30 then delite.show;

 ProgressBar1.Position:=ProgressBar1.Max;
 sleep(100);

// 
 {Application.Minimize;
 TrayIcon1.HideMainForm;}
 Form1.Hide;
 ShowWindow(Application.Handle, SW_HIDE);


 TrayIcon1.Visible:=true;    //    

 if REGname='' then registration.Show;

 reg.Free;
end;

procedure TForm1.TrayIcon1Click(Sender: TObject);
begin
 UpdateSettings;    // 

 TrayIcon1.Hint:='['+NowDate+']'+day;

 if OnClickShowForm<>'false' then ShowDate.Show;   //     

 if OnClickShowDialog<>'false' then
 begin
  TrayIcon1.BalloonHint:=day;
  TrayIcon1.BalloonTitle:='['+NowDate+']:';
  TrayIcon1.BalloonFlags:=bfInfo;
  TrayIcon1.ShowBalloonHint;
 end;
 if OnClickShowCal<>'false' then cal.Show;
end;

procedure TForm1.TrayIcon1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 updatesettings;
 if calTrayEnabled='true' then
 begin
  calTray.Show;
  calTray.Timer1.Enabled:=true;
 end;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
 registration.show;
end;

procedure TForm1.N3Click(Sender: TObject);
begin
 cal.Show;
end;

procedure TForm1.Settings1Click(Sender: TObject);
begin
 settings.show;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 about.show;
end;




end.
